package com.novaordis.thread194629;

import org.apache.log4j.Logger;
import org.infinispan.Cache;

/**
 * @author <a href="mailto:ovidiu@novaordis.com">Ovidiu Feodorov</a>
 *
 * Copyright 2012 Nova Ordis LLC
 */
class WriteAndRead implements Runnable
{
    // Constants -----------------------------------------------------------------------------------

    private static final Logger log = Logger.getLogger(WriteAndRead.class);

    // Static --------------------------------------------------------------------------------------

    // Attributes ----------------------------------------------------------------------------------

    private Cache<Object, Object> c;
    private String s;

    // Constructors --------------------------------------------------------------------------------

    WriteAndRead(Cache<Object, Object> c, String s)
    {
        this.c = c;
        this.s = s;
    }

    // Runnable implementation ---------------------------------------------------------------------

    public void run()
    {
        log.info("writing " + s);

        c.put(s, s);

        Object o = c.get(s);

        log.info("read " + o);

        if (!s.equals(o))
        {
            throw new RuntimeException("we did not get what we put into the cache");
        }
    }

    // Public --------------------------------------------------------------------------------------

    // Package protected ---------------------------------------------------------------------------

    // Protected -----------------------------------------------------------------------------------

    // Private -------------------------------------------------------------------------------------

    // Inner classes -------------------------------------------------------------------------------
}
